import java.util.*;
import javax.persistence.*;

@Entity
public class Alarm extends Event {
    private Date createdOn = new Date();
    private Event event;

    @OneToOne
    @JoinColumns({@JoinColumn(name="NOTIFICATIONID", 
                              referencedColumnName="NOTIFICATIONID",
                              insertable=false, updatable=false),
                  @JoinColumn(name="EVENT_DISCRIMINATORVALUE", 
                              referencedColumnName="DISCRIMINATORVALUE")})
    public Event getEvent() {
        return event;
    }

    public void setEvent(Event event) {
        this.event = event;
    }

    @Temporal(TemporalType.DATE)
    public Date getCreatedOn() {
        return createdOn;
    }

    public void setCreatedOn(Date createdOn) {
        this.createdOn = createdOn;
    }

    @Override public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("Alarm: id = " + getNotificationId() + " " + 
                      "type = " + getDiscriminatorValue() + " " +
                      "createdOn = " + getCreatedOn() + " " +
                      "->{[" + getEvent() + "]}");
        return sb.toString();
    }
}
